package com.sun.qeweb.annotations.test1.taglib;

import java.io.IOException;
import java.sql.Connection;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.tagext.TagSupport;

import javax.naming.*;
import javax.annotation.Resource;
import javax.annotation.Resources;
import javax.sql.DataSource;

import java.util.*;
import java.sql.*;
import javax.sql.*;

// TYPE(Class)-level @Resource annotations
@Resource(name="myDataSource4", mappedName="jdbc/__default", type=DataSource.class)
@Resources({ @Resource(name="myDataSource5",  mappedName="jdbc/__default", type=DataSource.class),
	     @Resource(name="jdbc/myDataSource6", type=javax.sql.DataSource.class)})

public class MyTag extends TagSupport {

    // annotation of instance variables
    @Resource(mappedName="jdbc/__default") private DataSource ds1;
    @Resource(name="myDataSource2") public DataSource ds2;
    private DataSource ds3;
    
    @Resource(name="jdbc/myDataSource3", mappedName="jdbc/__default")
    private void setDataSource(DataSource ds) {
        ds3 = ds;
    }


    public int doStartTag() throws JspException {

        try {

            JspWriter jsw = pageContext.getOut();

            int loginTimeout = ds1.getLoginTimeout();
            jsw.print("ds1-login-timeout=" + loginTimeout);
            System.out.println("doStartTag, ds1.loginTimeout="+loginTimeout);

            loginTimeout = ds2.getLoginTimeout();
            jsw.print(",ds2-login-timeout=" + loginTimeout);

            loginTimeout = ds3.getLoginTimeout();
            jsw.print(",ds3-login-timeout=" + loginTimeout);

            InitialContext ic = new InitialContext();

	    DataSource ds4 = (DataSource) 
                ic.lookup("java:comp/env/myDataSource4");
            loginTimeout = ds4.getLoginTimeout();
            jsw.print(",ds4-login-timeout=" + loginTimeout);


	    DataSource ds5 = (DataSource) 
                ic.lookup("java:comp/env/myDataSource5");
            loginTimeout = ds5.getLoginTimeout();
            jsw.print(",ds5-login-timeout=" + loginTimeout);

            DataSource ds6 = (DataSource)
                ic.lookup("java:comp/env/jdbc/myDataSource6");
            loginTimeout = ds6.getLoginTimeout();
            jsw.print(",ds6-login-timeout=" + loginTimeout);


        } catch (Exception ex) {
            System.out.println("doStartTag:getException");
            ex.printStackTrace();
            throw new JspException(ex);
        } 


        return SKIP_BODY;
    }
}
